---
title: metadata
type: processor
status: deprecated
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/processor/metadata.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

:::warning DEPRECATED
This component is deprecated and will be removed in the next major version release. Please consider moving onto [alternative components](#alternatives).
:::


<Tabs defaultValue="common" values={[
  { label: 'Common', value: 'common', },
  { label: 'Advanced', value: 'advanced', },
]}>

<TabItem value="common">

```yaml
# Common config fields, showing default values
label: ""
metadata:
  operator: set
  key: example
  value: ${!hostname()}
```

</TabItem>
<TabItem value="advanced">

```yaml
# All config fields, showing default values
label: ""
metadata:
  operator: set
  key: example
  value: ${!hostname()}
  parts: []
```

</TabItem>
</Tabs>

## Fields

### `operator`

The operator to apply to messages.


Type: `string`  
Default: `"set"`  
Options: `set`, `delete`, `delete_all`, `delete_prefix`.

### `key`

The metadata key to target with the chosen operator.
This field supports [interpolation functions](/docs/configuration/interpolation#bloblang-queries).


Type: `string`  
Default: `"example"`  

### `value`

The metadata value to use with the chosen operator.
This field supports [interpolation functions](/docs/configuration/interpolation#bloblang-queries).


Type: `string`  
Default: `"${!hostname()}"`  

### `parts`

An optional array of message indexes of a batch that the processor should apply to.
If left empty all messages are processed. This field is only applicable when
batching messages [at the input level](/docs/configuration/batching).

Indexes can be negative, and if so the part will be selected from the end
counting backwards starting from -1.


Type: `array`  
Default: `[]`  

## Alternatives

All functionality of this processor has been superseded by the
[bloblang](/docs/components/processors/bloblang) processor.

